// Licensed Materials - Property of IBM
// (c) Copyright IBM Corporation 2018, 2019. All Rights Reserved.
// Note to U.S. Government Users Restricted Rights:
// Use, duplication or disclosure restricted by GSA ADP Schedule
// Contract with IBM Corp.
// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/open-cluster-management/hcm-compliance/pkg/apis/accesspolicy/v1alpha1"
	"github.com/open-cluster-management/hcm-compliance/pkg/client/clientset/versioned/scheme"
	serializer "k8s.io/apimachinery/pkg/runtime/serializer"
	rest "k8s.io/client-go/rest"
)

type AccesspolicyV1alpha1Interface interface {
	RESTClient() rest.Interface
	AccessPoliciesGetter
}

// AccesspolicyV1alpha1Client is used to interact with features provided by the accesspolicy group.
type AccesspolicyV1alpha1Client struct {
	restClient rest.Interface
}

func (c *AccesspolicyV1alpha1Client) AccessPolicies(namespace string) AccessPolicyInterface {
	return newAccessPolicies(c, namespace)
}

// NewForConfig creates a new AccesspolicyV1alpha1Client for the given config.
func NewForConfig(c *rest.Config) (*AccesspolicyV1alpha1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientFor(&config)
	if err != nil {
		return nil, err
	}
	return &AccesspolicyV1alpha1Client{client}, nil
}

// NewForConfigOrDie creates a new AccesspolicyV1alpha1Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *AccesspolicyV1alpha1Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new AccesspolicyV1alpha1Client for the given RESTClient.
func New(c rest.Interface) *AccesspolicyV1alpha1Client {
	return &AccesspolicyV1alpha1Client{c}
}

func setConfigDefaults(config *rest.Config) error {
	gv := v1alpha1.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = serializer.DirectCodecFactory{CodecFactory: scheme.Codecs}

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *AccesspolicyV1alpha1Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
